## Invocation

This section describes how invoke Boost.Build from the command line

To build all targets defined in Jamfile in the current directory with default properties, run:

    bjam

To build specific targets, specify them on the command line:

    bjam lib1 subproject//lib2

To request a certain value for some property, add ``property`=`value`` to the command line:

    bjam toolset=gcc variant=debug optimization=space

For often used features, like `toolset` and `variant` you can omit the feature name, so the above can be written as:

    bjam optimization=space

Boost.Build recognizes the following command line options.

`--clean`

  Cleans all targets in the current directory and in any subprojects. Note that unlike the `clean` target in make, you can use `--clean` together with target names to clean specific targets.

`--clean-all`

  Cleans all targets, no matter where they are defined. In particular, it will clean targets in parent Jamfiles, and targets defined under other project roots.

`--build-dir`

  Changes build directories for all project roots being built. When this option is specified, all Jamroot files should declare project name. The build directory for the project root will be computed by concatanating the value of the `--build-dir` option, the project name specified in Jamroot, and the build dir specified in Jamroot (or `bin`, if none is specified).

  The option is primarily useful when building from read-only media, when you can't modify Jamroot.

`--version`

  Prints information on Boost.Build and Boost.Jam versions.

`--help`

  Invokes the online help system. This prints general information on how to use the help system with additional --help* options.

`--debug-configuration`

  Produces debug information about loading of Boost.Build and toolset files.

`--debug-building`

  Prints what targets are being built and with what properties.

`--debug-generators`

  Produces debug output from generator search process. Useful for debugging custom generators.

`--ignore-config`

  Do not load `site-config.jam` and `user-config.jam` configuration files.

`--debug`

  Enables internal checks.

For complete specification of command line syntax, see the section called “Command line arguments”